import math
import cmath
import matplotlib.pyplot as p
import PS8_tests
from PS2_1 import data_recovery
from PS2_2 import receive_8b10b

# return digitized samples from the frequency band centered at kdemod.
def quadrature_demod(samples,kdemod,kcutoff):
    #first need to limit samples
    samples = samples[kdemod-kcutoff:kdemod+kcutoff]

##    #only one time step here
##    n = 1
##
##    #print samples
##    N=len(samples)
##    print N
##    k=-math.floor(N/2)
##    kcount = 0
##    print k
##    ans = 0
##    pass
##    while kcount<N:
##        print 'this is k='+str(k)
##        ans = ans + samples[kcount]*cmath.exp(complex(0,-k*(2*cmath.pi)/N*n))
##        k = k+1
##        kcount = kcount+1
##        print ans
##    return [ans]

#cos
    def cos(samples):
        fseq = samples
        #print fseq[800]
        N=len(fseq)
        #print N
        n = 0
        x = []
        while n<N:
            #find xn
            #print 'this is x['+str(n)+']'
            xn = 0
            #sum over all the ks
            r = range(-math.floor(N/2),math.floor(N/2),1)
            kcount = 0
            #print r
            #print len(r)
            for k in r:
                xn = fseq[kcount]*cmath.exp(complex(0,k*(2*cmath.pi)/N*n))+xn
                #print xn
                #print kcount
                kcount=kcount+1
            #print 'final'
            #only want real
            #print xn.real
            x.append(xn.real)
            n=n+1
        return xrange

#sin
    def sin(samples):
        fseq = samples
        #print fseq[800]
        N=len(fseq)
        #print N
        n = 0
        x = []
        while n<N:
            #find xn
            #print 'this is x['+str(n)+']'
            xn = 0
            #sum over all the ks
            r = range(-math.floor(N/2),math.floor(N/2),1)
            kcount = 0
            #print r
            #print len(r)
            for k in r:
                xn = fseq[kcount]*cmath.exp(complex(0,k*(2*cmath.pi)/N*n))+xn
                #print xn
                #print kcount
                kcount=kcount+1
            #print 'final'
            #only want real
            #print xn.real
            x.append(xn.real)
            n=n+1
        return xrange


# read in samples for the shared channel
samples = PS8_tests.read_wav_file('PS8_rf.wav')

# take a look at the spectrum we received
p.figure()
PS8_tests.plot_spectrum_magnitude(samples)
p.title('$|a_k|$ for received signal')
p.show()

# recover one of the messages by demodulating the appropriate
# piece of the spectrum down to baseband.
#first one
kdemod = 1000
#plus or minus around center
kcutoff = 400
digitized_samples = quadrature_demod(samples,kdemod,kcutoff)
print digitized_samples

# recover bits from digitized samples
samples_per_bit = 20
bits = data_recovery(digitized_samples,samples_per_bit)

# decode 8b10b-encoded packets
msg = receive_8b10b(bits)

# print result!
print msg
